import { useReducer } from "react"

type Component = {
    appComponentId: number,//组件ID
    componentType:string,//
    pageUrl:string,
    configs:any[],//组件配置
}
type State = {
    tabs: 0 | 1,//男生女生选项
    compAc: string,//当前选中的组件,切换tabs请0
    manList: Component[]//男生配置
    womanList: Component[]//女生配置
    index:number,//每次操作修改数据都递增，为了检测到数据变动
}
type Action = {
    params?: any,
    type: "setAll",
}
export function reducer(state: State, action: Action) {
    let { type, params } = action
    switch (type) {
        case 'setAll':
            return { ...state, ...params }
        default:
            return state;
    }
}
export default (): { state: State, dispatch: React.Dispatch<Action> } => {
    const [state, dispatch] = useReducer(reducer, {
        tabs: 0,
        compAc: "",
        manList: [],
        womanList: [],
        index:0
    })
    return {
        state,
        dispatch
    }
}